SET DEFINE OFF;
whenever sqlerror exit sql.sqlcode ;

-- Recréation de la table ACCORDS.AVENANT_EVT_EVENEMENT
CREATE TABLE ACCORDS.AVENANT_EVT_EVENEMENT
  (
    AVT_ORDRE NUMBER(38,0) NOT NULL,
    EVT_ID NUMBER(22,0) NOT NULL,
    PRIMARY KEY (AVT_ORDRE, EVT_ID) USING INDEX TABLESPACE GFC
  )
  TABLESPACE GFC ;
  COMMENT ON COLUMN ACCORDS.AVENANT_EVT_EVENEMENT.AVT_ORDRE
IS
  'Cle de l''avenant';
  COMMENT ON COLUMN ACCORDS.AVENANT_EVT_EVENEMENT.EVT_ID
IS
  'Cle de l''evenement';
  COMMENT ON TABLE ACCORDS.AVENANT_EVT_EVENEMENT
IS
  'Evenements lies aux conventions';

GRANT REFERENCES ON GRHUM.EVT_EVENEMENT TO ACCORDS;
GRANT SELECT ON GRHUM.EVT_EVENEMENT TO ACCORDS;
  
ALTER TABLE ACCORDS.AVENANT_EVT_EVENEMENT ADD (
  CONSTRAINT FK_AVENANT FOREIGN KEY (AVT_ORDRE) REFERENCES ACCORDS.AVENANT (AVT_ORDRE) DEFERRABLE INITIALLY DEFERRED) ;

ALTER TABLE ACCORDS.AVENANT_EVT_EVENEMENT ADD (
  CONSTRAINT FK_EVENEMENT FOREIGN KEY (EVT_ID) REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID) DEFERRABLE INITIALLY DEFERRED);  
 
  
-- TODO : migrer les tables existantes : EVENEMENT, AVENANT_EVENEMENT, NATURE_EVENEMENT, REPART_INDIVIDU_EVT 
-- vers les nouvelles tables de grhum...

-- Puis drop des objets
--drop table ACCORDS.EVENEMENT;
--drop sequence ACCORDS.EVENEMENT_SEQ;
--drop table ACCORDS.AVENANT_EVENEMENT;
--drop sequence ACCORDS.AVENANT_EVENEMENT_SEQ;
--drop table ACCORDS.NATURE_EVENEMENT;
--drop table ACCORDS.REPART_INDIVIDU_EVT;
--drop sequence ACCORDS.REPART_INDIVIDU_EVT_SEQ;


-- TABLE JOINTURE SB_RECETTE / CODE_ANALYTIQUE
CREATE TABLE ACCORDS.REPART_SB_RECETTE_C_ANALYTIQUE
(
  SR_ORDRE NUMBER NOT NULL,
  MONTANT_HT NUMBER(12,2) NOT NULL,
  CAN_ID NUMBER NOT NULL 
)
TABLESPACE GFC;
ALTER TABLE ACCORDS.REPART_SB_RECETTE_C_ANALYTIQUE ADD (
  PRIMARY KEY
 (SR_ORDRE, CAN_ID)
    USING INDEX 
    TABLESPACE GFC
 );
ALTER TABLE ACCORDS.REPART_SB_RECETTE_C_ANALYTIQUE ADD (
  CONSTRAINT FK_REP_C_ANALYTIQUE_SB_RECETTE 
 FOREIGN KEY (SR_ORDRE) 
 REFERENCES ACCORDS.SB_RECETTE (SR_ORDRE));
ALTER TABLE ACCORDS.REPART_SB_RECETTE_C_ANALYTIQUE ADD (
  CONSTRAINT FK_REP_CODE_ANALYTIQUE 
 FOREIGN KEY (CAN_ID) 
 REFERENCES JEFY_ADMIN.CODE_ANALYTIQUE (CAN_ID));
 
 -- TABLE JOINTURE SB_RECETTE / PLAN_CO
CREATE TABLE ACCORDS.REPART_SB_RECETTE_PLANCO
(
  SR_ORDRE NUMBER NOT NULL,
  MONTANT_HT NUMBER(12,2) NOT NULL,
  PCO_NUM VARCHAR2(20) NOT NULL 
)
TABLESPACE GFC;
ALTER TABLE ACCORDS.REPART_SB_RECETTE_PLANCO ADD (
  PRIMARY KEY
 (SR_ORDRE, PCO_NUM)
    USING INDEX 
    TABLESPACE GFC
 );
ALTER TABLE ACCORDS.REPART_SB_RECETTE_PLANCO ADD (
  CONSTRAINT FK_REP_PLANCO_SB_RECETTE 
 FOREIGN KEY (SR_ORDRE) 
 REFERENCES ACCORDS.SB_RECETTE (SR_ORDRE));
ALTER TABLE ACCORDS.REPART_SB_RECETTE_PLANCO ADD (
  CONSTRAINT FK_REP_PLANCO 
 FOREIGN KEY (PCO_NUM) 
 REFERENCES MARACUJA.PLAN_COMPTABLE (PCO_NUM));
 
 -- TABLE JOINTURE SB_DEPENSE / CODE_ANALYTIQUE
CREATE TABLE ACCORDS.REPART_SB_DEPENSE_C_ANALYTIQUE
(
  SD_ORDRE NUMBER NOT NULL,
  MONTANT_HT NUMBER(12,2) NOT NULL,
  CAN_ID NUMBER NOT NULL 
)
TABLESPACE GFC;
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_C_ANALYTIQUE ADD (
  PRIMARY KEY
 (SD_ORDRE, CAN_ID)
    USING INDEX 
    TABLESPACE GFC
 );
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_C_ANALYTIQUE ADD (
  CONSTRAINT FK_REP_C_ANALYTIQUE_SB_DEPENSE 
 FOREIGN KEY (SD_ORDRE) 
 REFERENCES ACCORDS.SB_DEPENSE (SD_ORDRE));
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_C_ANALYTIQUE ADD (
  CONSTRAINT FK_REP_SD_CODE_ANALYTIQUE 
 FOREIGN KEY (CAN_ID) 
 REFERENCES JEFY_ADMIN.CODE_ANALYTIQUE (CAN_ID));
 
 -- TABLE JOINTURE SB_DEPENSE / PLAN_CO
CREATE TABLE ACCORDS.REPART_SB_DEPENSE_PLANCO
(
  SD_ORDRE NUMBER NOT NULL,
  MONTANT_HT NUMBER(12,2) NOT NULL,
  PCO_NUM VARCHAR2(20) NOT NULL 
)
TABLESPACE GFC;
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_PLANCO ADD (
  PRIMARY KEY
 (SD_ORDRE, PCO_NUM)
    USING INDEX 
    TABLESPACE GFC
 );
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_PLANCO ADD (
  CONSTRAINT FK_REP_PLANCO_SB_DEPENSE 
 FOREIGN KEY (SD_ORDRE) 
 REFERENCES ACCORDS.SB_DEPENSE (SD_ORDRE));
ALTER TABLE ACCORDS.REPART_SB_DEPENSE_PLANCO ADD (
  CONSTRAINT FK_REP_SD_PLANCO 
 FOREIGN KEY (PCO_NUM) 
 REFERENCES MARACUJA.PLAN_COMPTABLE (PCO_NUM));

-- FK SB_RECETTE -> TYPE_CREDIT
ALTER TABLE ACCORDS.SB_RECETTE ADD (
  CONSTRAINT FK_RECETTE_TC 
 FOREIGN KEY (TCD_ORDRE) 
 REFERENCES JEFY_ADMIN.TYPE_CREDIT (TCD_ORDRE));
 
-- FK SB_DEPENSE / TYPE_CREDIT
ALTER TABLE ACCORDS.SB_DEPENSE ADD (
  CONSTRAINT FK_DEPENSE_TC 
 FOREIGN KEY (TCD_ORDRE) 
 REFERENCES JEFY_ADMIN.TYPE_CREDIT (TCD_ORDRE));
 
-- FK SB_RECETTE / LOLF
ALTER TABLE ACCORDS.SB_RECETTE ADD (
  CONSTRAINT FK_REC_LOLF 
 FOREIGN KEY (LOLF_ID) 
 REFERENCES JEFY_ADMIN.LOLF_NOMENCLATURE_RECETTE (LOLF_ID));

-- FK SB_DEPENSE / LOLF
ALTER TABLE ACCORDS.SB_DEPENSE ADD (
  CONSTRAINT FK_DEP_LOLF 
 FOREIGN KEY (LOLF_ID) 
 REFERENCES JEFY_ADMIN.LOLF_NOMENCLATURE_DEPENSE (LOLF_ID));
 
----------------------------------------------------------
-- Procédure de migration des reparts depense et recette
----------------------------------------------------------
CREATE OR REPLACE package ACCORDS.TRANSFERT_REPARTS is

  procedure transferer_reparts;

end TRANSFERT_REPARTS;
/


CREATE OR REPLACE package body ACCORDS.TRANSFERT_REPARTS as
  
  procedure transferer_reparts
  is
   CURSOR C_REC is select * from ACCORDS.SB_RECETTE;
   CURSOR C_DEP is select * from ACCORDS.SB_DEPENSE;
   REC ACCORDS.SB_RECETTE%rowtype;
   DEP ACCORDS.SB_DEPENSE%rowtype;
   begin
    open C_REC;
    loop
     fetch C_REC into REC;
     exit when C_REC%notfound;
     -- pareil pour PCO_NUM
     if (REC.PCO_NUM is not null) then
      insert into ACCORDS.REPART_SB_RECETTE_PLANCO (SR_ORDRE,MONTANT_HT,PCO_NUM) values (REC.SR_ORDRE,REC.SR_MONTANT_HT,REC.PCO_NUM);
     end if;
     -- pareil pour CAN_ID
     if (REC.CAN_ID is not null) then
      insert into ACCORDS.REPART_SB_RECETTE_C_ANALYTIQUE (SR_ORDRE,MONTANT_HT,CAN_ID) values (REC.SR_ORDRE,REC.SR_MONTANT_HT,REC.CAN_ID);
     end if;
    end loop;
    close C_REC;
    open C_DEP;
    loop
     fetch C_DEP into DEP;
     exit when C_DEP%notfound;
     -- pareil pour PCO_NUM
     if (DEP.PCO_NUM is not null) then
        insert into ACCORDS.REPART_SB_DEPENSE_PLANCO (SD_ORDRE,MONTANT_HT,PCO_NUM) values (DEP.SD_ORDRE,DEP.SD_MONTANT_HT,DEP.PCO_NUM);
     end if;
     -- pareil pour CAN_ID
     if (DEP.CAN_ID is not null) then
        insert into ACCORDS.REPART_SB_DEPENSE_C_ANALYTIQUE (SD_ORDRE,MONTANT_HT,CAN_ID) values (DEP.SD_ORDRE,DEP.SD_MONTANT_HT,DEP.CAN_ID);
     end if;
    end loop;
    close C_DEP;
  end transferer_reparts;
  
  end TRANSFERT_REPARTS;
  /


-- Ajout des attributs de date de creation et de responsable
ALTER TABLE ACCORDS.PROJET
 ADD (
    PERS_ID_RESPONSABLE NUMBER,
    PJT_DATE_CREATION DATE
 );
COMMENT ON COLUMN ACCORDS.PROJET.PERS_ID_RESPONSABLE IS 'Responsable du projet';
COMMENT ON COLUMN ACCORDS.PROJET.PJT_DATE_CREATION IS 'Date de creation du projet';

-- Ajout d'un attribut TVA_ID cle primaire de JEFY_ADMIN.TVA
ALTER TABLE ACCORDS.AVENANT
 ADD (
    AVT_TVA_ID NUMBER
 );
ALTER TABLE ACCORDS.AVENANT ADD (
  CONSTRAINT FK_AVT_TVA 
 FOREIGN KEY (AVT_TVA_ID) 
 REFERENCES JEFY_ADMIN.TVA (TVA_ID));
 
-- Ajout d'un attribut TVA_ID cle primaire de JEFY_ADMIN.TVA
ALTER TABLE ACCORDS.SB_DEPENSE
 ADD (
    TVA_ID NUMBER
 );
ALTER TABLE ACCORDS.SB_DEPENSE ADD (
  CONSTRAINT FK_SB_DEP_TVA 
 FOREIGN KEY (TVA_ID) 
 REFERENCES JEFY_ADMIN.TVA (TVA_ID));
 
-- Ajout d'un attribut TVA_ID cle primaire de JEFY_ADMIN.TVA
ALTER TABLE ACCORDS.SB_RECETTE
 ADD (
    TVA_ID NUMBER
 );
 ALTER TABLE ACCORDS.SB_RECETTE ADD (
  CONSTRAINT FK_SB_REC_TVA 
 FOREIGN KEY (TVA_ID) 
 REFERENCES JEFY_ADMIN.TVA (TVA_ID));
 
 -- Autoriser les NULL dans org_id
alter table ACCORDS.SB_DEPENSE MODIFY(ORG_ID  NULL);
alter table ACCORDS.SB_RECETTE MODIFY(ORG_ID  NULL);


-- Maj de  la version 
Insert into ACCORDS.VERSION_HISTO (VH_ORDRE,VH_NUM,VH_DATE_EXEC,VH_LIBELLE) values (accords.VERSION_HISTO_SEQ.nextval,'2.1.0',to_date('20/01/2011','DD/MM/YYYY'),'Ajout TVA_ID, modifs Projet, ajout de reparts depense et recette');

commit;